//----------------------------------------------------------------
//CodeArt (2009)
//
//File Description/ļ:
//
//Author/  : jianyi(jianyi0115@163.com)
//Blogs: cnblogs.com/jianyi0115
//You can send your Issue to my mailbox or Put it on the BBS:http://bbs.msiw.net/
//Created/: 2008-12-18
//
//Modified Log/޶¼: 
//
//----------------------------------------------------------------
using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Xml;
using System.Diagnostics;
using System.Xml.Serialization;

namespace SPCAMLEditor
{
    [Serializable]
    public class Config
    {
        const string FILE_NANME = "SPCAMLEditor.xml";

        const string LATEST_CONFIG_VERSION = "1.2";

        public const string PREVIEW_CONTRL_ASSAMBLE = "SPCAMLEditor.Web, Version=1.0.0.0, Culture=neutral, PublicKeyToken=533fd547114ff6f2";

        public bool GACRegisterd = false;
        public string SiteUrl;

        public string ConfigVersion = "" ;

        public bool AutoSaveViewSchema = false ;
        public bool AutoSaveFieldSchema = false ;

        public bool IsLatestConfigVersion
        {
            get
            {
                return ConfigVersion == LATEST_CONFIG_VERSION;
            }
        }

        private static Config _cfg;
        public static Config LoadConfig()
        {
            if (_cfg != null)
                return _cfg;

           XmlSerializer xs = new XmlSerializer(typeof(Config));

           string fullPath = Environment.CurrentDirectory + "\\" + FILE_NANME;

           if (!File.Exists(fullPath))
           {
               _cfg = new Config();
               return _cfg;
           }

           FileStream fs = File.Open(fullPath, FileMode.Open);
           XmlTextReader xr = new XmlTextReader(fs);

           object obj = xs.Deserialize(xr);

           fs.Close();
           fs.Dispose();

           _cfg = obj as Config;

           return _cfg;
        }

        public void Save()
        {
            this.ConfigVersion = LATEST_CONFIG_VERSION;

            XmlSerializer xs = new XmlSerializer( this.GetType() );

            string fullPath = Environment.CurrentDirectory + "\\" + FILE_NANME ;

            File.Delete(fullPath);

            FileStream fs = File.Open(fullPath, FileMode.Create);
          
            XmlTextWriter w = new XmlTextWriter(fs, Encoding.UTF8);

            xs.Serialize(w, this);
            fs.Close();
            fs.Dispose();
        }
    }

 
}
