//----------------------------------------------------------------
//CodeArt (2009)
//
//File Description/ļ:
//
//Author/  : jianyi(jianyi0115@163.com)
//Blogs: cnblogs.com/jianyi0115
//You can send your Issue to my mailbox or Put it on the BBS:http://bbs.msiw.net/
//Created/: 2008-12-18
//
//Modified Log/޶¼: 
//
//----------------------------------------------------------------
using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Xml;
using System.Reflection;
using Microsoft.SharePoint;
 

namespace SPCAMLEditor
{
    class ContentTypeHandler : EndNodeHandler
    {
        private SPContentType _contentType;
        private SPWeb _web;

        public ContentTypeHandler(TreeNode node, SPWeb web, SPContentType ct)
            : base(node)
        {
            _contentType = ct ;
            _web = web ;
        }

        public override object NodeData
        {
            get
            {
                return _contentType;
            }
        }

        public override string NodeText
        {
            get
            {
                return "ContentType-" + _contentType.Name;
            }
        }

        public override string SettingUrl
        {
            get
            {
                return _web.Url + "/_layouts/ManageContentType.aspx?ctype=" + _contentType.Id;
            }
        }

        public override bool AllowImportSchemal
        {
            get
            {
                return false ;
            }
        }

        public override bool AllowCopy
        {
            get
            {
                return false;
            }
        }

        public override bool AllowUpdateSchemal
        {
            get
            {
                return false;
            }
        }
        

        public override string SchemalXml
        {
            get
            {
                return _contentType.SchemaXml;
            }
        }

        public override void CopyNodeData()
        {
        }

        public override void UpdateNodeData()
        {
            _contentType.Update(true);
        }         

        public override void UpdateNodeDataSchemal(XmlDocument xml)
        {
           
        }

        public override void DeleteNodeData()
        {
            _contentType.Delete();
            this.Node.Remove(); 
        }

        public override void OnPreview(NodeAssoationArgs controls)
        {

        }

        public override void ReflashNode(NodeAssoationArgs controls)
        {
             
        }

        public override void OnNodeClick(NodeAssoationArgs controls)
        {           
            Node.ContextMenuStrip = controls.ContextMenuStrip;

            controls.XmlEditor.Xml = _contentType.SchemaXml;
        }
         
    }
}
