//----------------------------------------------------------------
//CodeArt (2009)
//
//File Description/ļ:
//
//Author/  : jianyi(jianyi0115@163.com)
//Blogs: cnblogs.com/jianyi0115
//You can send your Issue to my mailbox or Put it on the BBS:http://bbs.msiw.net/
//Created/: 2008-12-18
//
//Modified Log/޶¼: 
//
//----------------------------------------------------------------
using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using Microsoft.SharePoint;

namespace SPCAMLEditor
{
    class ContentTypesGroupHandler : NodeHandler
    {
        private SPWeb _web;
        public ContentTypesGroupHandler(TreeNode node, SPWeb web)
            : base(node)
        {
            _web = web ;
        }

        public override object NodeData
        {
            get { return null ; }
        }

        public override string SettingUrl
        {
            get
            {
                return _web.Url + "/_layouts/mngctype.aspx";
            }
        }        
         
        public override void BuildChildNodes()
        {
            Dictionary<string, TreeNode> group = new Dictionary<string, TreeNode>();

            foreach ( SPContentType f in _web.ContentTypes )
            {
                TreeNode node = new TreeNode();
                node.Text = f.Name  ;
                node.Tag = new ContentTypeHandler(node, _web, f);
                node.ToolTipText = f.Description;

                node.ImageIndex = ImageListIndex.Field;
                node.SelectedImageIndex = ImageListIndex.Field;

                if (group.ContainsKey(f.Group))
                {
                    group[f.Group].Nodes.Add(node);
                }
                else
                {
                    TreeNode groupNode = new TreeNode();
                    groupNode.Text = f.Group;
                    groupNode.Tag = null;

                    groupNode.ImageIndex = ImageListIndex.FieldGroup;
                    groupNode.SelectedImageIndex = ImageListIndex.FieldGroup;

                    groupNode.ContextMenuStrip = AppContext.FindContentMenuStrip;

                    base.Node.Nodes.Add(groupNode);

                    group.Add(f.Group, groupNode);

                    groupNode.Nodes.Add(node);
                }
            }
        }

        
 
    }
}
