//----------------------------------------------------------------
//CodeArt (2009)
//
//File Description/ļ:
//
//Author/  : jianyi(jianyi0115@163.com)
//Blogs: cnblogs.com/jianyi0115
//You can send your Issue to my mailbox or Put it on the BBS:http://bbs.msiw.net/
//Created/: 2008-12-18
//
//Modified Log/޶¼: 
//
//----------------------------------------------------------------
using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using Microsoft.SharePoint;
using System.Xml;

namespace SPCAMLEditor
{
    public class NodeHandler
    {
        protected TreeNode Node;
        public NodeHandler(TreeNode node )
        {
            Node = node;
        }

        public virtual object NodeData
        {
            get { return null; }
        }

        public virtual string NodeText
        {
            get
            {
                return "";
            }
        }

        public virtual string SettingUrl
        {
            get { return null; }
        }

        public virtual string PageUrl
        {
            get { return null; }
        }

        public virtual bool AllowUpdateSchemal
        {
            get { return false; }
        }

        public virtual bool AllowExportSchemal
        {
            get { return false; }
        }

        public virtual bool AllowImportSchemal
        {
            get { return false; }
        }

        public virtual bool AllowCopy
        {
            get { return false; }
        }

        public virtual bool AllowDelete
        {
            get { return false; }
        }

        public virtual bool AllowEditProperty
        {
            get { return true ; }
        }

        public virtual string SchemalXml
        {
            get
            {
                return "";
            }
        }

        //private TreeNode _Node;
        //public TreeNode Node
        //{
        //    set { _ }
        //}

       // public virtual TreeNode BuildNode() { }

        public void BuildEmptyNode(TreeNode parentNode)
        {
            TreeNode emptyNode = new TreeNode();
            emptyNode.Text = "Loading...";
            parentNode.Nodes.Add(emptyNode);
            parentNode.Collapse();
        }

        public virtual void BuildChildNodes() { }

        public virtual void ReflashNode(NodeAssoationArgs controls) { }

        public virtual void UpdateNodeData()
        {

        }

        public virtual void UpdateNodeDataSchemal( XmlDocument xml )
        {

        }

        public virtual void CopyNodeData()
        {

        }

        public virtual void DeleteNodeData()
        {

        }

        public virtual void OnNodeExpand()
        {
            if (this.Node.Nodes.Count == 1 && this.Node.Nodes[0].Tag == null)
            {
                this.Node.Nodes.Clear();
                this.BuildChildNodes();
            }
        }

        public virtual void OnPreview(NodeAssoationArgs controls)
        {

        }

        public virtual void OnNodeClick( NodeAssoationArgs controls )
        {

        }
    }

    public class NodeAssoationArgs
    {
        public NodeAssoationArgs( WebBrowser b , IXmlTextEditor editor )
        {
            UIBrowser = b;
            XmlEditor = editor ;
        }

        public readonly WebBrowser UIBrowser;

        public readonly IXmlTextEditor XmlEditor;

        public SPWeb CurrentWeb;

        public SPList CurrentList;

        public SPView CurrentView;

        public SPField CurrentField;

        public ContextMenuStrip ContextMenuStrip;

        //public ContextMenuStrip FindContentMenuStrip;
    }
}
