//----------------------------------------------------------------
//CodeArt (2009)
//
//File Description/ļ:
//
//Author/  : jianyi(jianyi0115@163.com)
//Blogs: cnblogs.com/jianyi0115
//You can send your Issue to my mailbox or Put it on the BBS:http://bbs.msiw.net/
//Created/: 2008-12-18
//
//Modified Log/޶¼: 
//
//----------------------------------------------------------------
using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using Microsoft.SharePoint;

namespace SPCAMLEditor
{
    class SPWebHandler : NodeHandler
    {
        private SPWeb _web;
        public SPWebHandler(TreeNode node, SPWeb web)
            : base(node)
        {
            _web = web ;
        }

        public override object NodeData
        {
            get { return _web; }
        }

        public override string SettingUrl
        {
            get
            {
                return _web.Url + "/_layouts/settings.aspx";
            }
        }

        public override string PageUrl
        {
            get
            {
                return _web.Url;
            }
        }

        public override string NodeText
        {
            get
            {
                return "Web-" + _web.Title;
            }
        }

        public override void DeleteNodeData()
        {
            _web.Delete();
            this.Node.Remove();
        }

       
        public override void UpdateNodeData()
        {
            _web.Update();
            this.Node.Text = _web.Title;
        }
         
        public override void BuildChildNodes()
        {
            if (_web.Fields.Count > 0)
            {
                TreeNode fieldsNode = new TreeNode();
                fieldsNode.Text = "Fields";
                fieldsNode.Tag = NodeHandlerFactory.GetDefaultNodeHandler(fieldsNode);
                fieldsNode.ImageIndex = ImageListIndex.FieldGroup;
                fieldsNode.SelectedImageIndex = ImageListIndex.FieldGroup;

                //fieldsNode.ContextMenuStrip = AppContext.FindContentMenuStrip;

                fieldsNode.Collapse();
                this.Node.Nodes.Add(fieldsNode);

                BuildWebFields(fieldsNode);
            }

            if (_web.ContentTypes.Count > 0)
            {
                TreeNode ctNode = new TreeNode();
                ctNode.Text = "ContentTypes";
                ctNode.Tag = new ContentTypesGroupHandler(ctNode, _web);
                ctNode.ImageIndex = ImageListIndex.FieldGroup;
                ctNode.SelectedImageIndex = ImageListIndex.FieldGroup;

                ctNode.Collapse();
                this.Node.Nodes.Add(ctNode);
                BuildEmptyNode(ctNode);
            }

            foreach (SPList list in _web.Lists)
            {
                TreeNode node = new TreeNode();
                node.Text = list.Title;
                node.Tag = NodeHandlerFactory.GetSPListHandler( node , list ) ;
                node.ImageIndex = ImageListIndex.List ;
                node.SelectedImageIndex = 1;
                this.Node.Nodes.Add(node);
                BuildEmptyNode(node);
            } 

            foreach (SPWeb w in _web.Webs)
            {
                TreeNode webNode = new TreeNode();
                webNode.Text = w.Title;
                webNode.ImageIndex = ImageListIndex.Web;
                webNode.SelectedImageIndex = 0;
                webNode.Tag = NodeHandlerFactory.GetSPWebHandler(webNode, w); ;
                this.Node.Nodes.Add(webNode);

                this.BuildEmptyNode(webNode);
            }
        }

        void BuildWebFields( TreeNode pNode )
        {
            Dictionary<string, TreeNode> group = new Dictionary<string, TreeNode>();

            foreach (SPField f in _web.Fields)
            {
                TreeNode node = new TreeNode();
                node.Text = f.Title + f.AuthoringInfo;
                node.Tag = NodeHandlerFactory.GetWebFieldHandler( node , _web , f ) ;
                node.ToolTipText = f.Description;

                node.ImageIndex = ImageListIndex.Field;
                node.SelectedImageIndex = ImageListIndex.Field;

                if (group.ContainsKey(f.Group))
                {
                    group[f.Group].Nodes.Add(node);
                }
                else
                {
                    TreeNode groupNode = new TreeNode();
                    groupNode.Text = f.Group;
                    groupNode.Tag = null;

                    groupNode.ImageIndex = ImageListIndex.FieldGroup;
                    groupNode.SelectedImageIndex = ImageListIndex.FieldGroup;

                    pNode.Nodes.Add(groupNode);

                    group.Add(f.Group, groupNode);

                    groupNode.Nodes.Add(node);

                    groupNode.ContextMenuStrip = AppContext.FindContentMenuStrip;
                }
            }
        }

        public override void OnNodeClick(NodeAssoationArgs controls)
        {
            controls.UIBrowser.AllowNavigation = true;
            controls.UIBrowser.Url = new Uri(_web.Url );
        }
 
    }
}
