//----------------------------------------------------------------
//CodeArt (2009)
//
//File Description/ļ:
//
//Author/  : jianyi(jianyi0115@163.com)
//Blogs: cnblogs.com/jianyi0115
//You can send your Issue to my mailbox or Put it on the BBS:http://bbs.msiw.net/
//Created/: 2008-12-18
//
//Modified Log/޶¼: 
//
//----------------------------------------------------------------
using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using Microsoft.SharePoint;

namespace SPCAMLEditor
{
    abstract class TreeNodeBuilder
    {
        protected TreeNode ParentNode;
        public TreeNodeBuilder( TreeNode node )
        {
            ParentNode = node;
        }

        public abstract void Build();
    }

    class WebFieldsNodeBuilder : TreeNodeBuilder
    {
        private SPWeb _web;
        public WebFieldsNodeBuilder( SPWeb web , TreeNode pNode ) : base(pNode)
        {
            _web = web;
        }

        public override void Build()
        {
            this.ParentNode.Nodes.Clear();

            Dictionary<string, TreeNode> group = new Dictionary<string, TreeNode>();

            foreach (SPField f in _web.Fields)
            {
                TreeNode node = new TreeNode ();
                node.Text = f.Title + f.AuthoringInfo;
                node.Tag = f ;
                node.ToolTipText = f.Description ;

                if (group.ContainsKey(f.Group))
                {
                    group[f.Group].Nodes.Add(node);
                }
                else
                {
                    TreeNode groupNode = new TreeNode();
                    groupNode.Text = f.Group;
                    groupNode.Tag = null;

                    this.ParentNode.Nodes.Add(groupNode);

                    group.Add(f.Group, groupNode);

                    groupNode.Nodes.Add( node );
                }
            }
        }
    }
}
